PRINT '<HTML><HEAD><TITLE>SQL - Script - by dia2sql.pl</TITLE></HEAD><BODY><H1>SQL setup log</H2>'

PRINT '<LI>Creating tables'

CREATE DATABASE smdp
GO
USE smdp
GO

CREATE TABLE album (
	id INT IDENTITY,
	audio_class_id INT,
	artist_id INT,
	album_name VARCHAR(255),
	track_list TEXT,
	PRIMARY KEY(id)
);


CREATE TABLE lyrics (
	song_id INT,
	lyrics TEXT
);


CREATE TABLE musicbrainz (
	song_id INT,
	TRM_id VARCHAR(255),
	artist VARCHAR(255),
	album VARCHAR(255),
	title VARCHAR(255),
	genre VARCHAR(255),
	year INT
);


CREATE TABLE freedb (
	album_id INT,
	genre INT,
	discid VARCHAR(10),
	dtitle VARCHAR(255),
	dartist VARCHAR(255),
	extd TEXT
);


CREATE TABLE correlations (
	object_1 INT,
	object_2 INT,
	relation SMALLINT,
	type INT
);


CREATE TABLE song (
	id INT IDENTITY,
	genre_id INT,
	album_id INT,
	artist_id INT,
	file_id INT,
	PRIMARY KEY(id)
);


CREATE TABLE media (
	id INT IDENTITY,
	name VARCHAR(20),
	PRIMARY KEY(id)
);


CREATE TABLE media_file (
	id INT IDENTITY,
	media_id INT,
	filename VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE file_feature (
	id INT IDENTITY,
	file_id INT,
	feature_id INT,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE media_feature (
	id INT IDENTITY,
	media_id INT,
	feature_id INT,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE song_feature (
	id INT IDENTITY,
	song_id INT,
	feature_id INT,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE artist (
	id INT IDENTITY,
	artist_name VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE artist_feature (
	id INT IDENTITY,
	artist_id INT,
	feature_id INT,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE audio_class (
	id INT IDENTITY,
	audio_class_type_id INT,
	descr VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE audio_class_type (
	id INT IDENTITY,
	descr VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE collection (
	id INT,
	name VARCHAR(255)
);


CREATE TABLE collection_feature (
	id INT,
	collection_id INT,
	feature_id INT,
	type VARCHAR(255)
);


CREATE TABLE tag_feature (
	id INT IDENTITY,
	tag_id INT,
	feature_id INT,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE tag (
	id INT IDENTITY,
	file_id INT,
	name VARCHAR(20),
	PRIMARY KEY(id)
);


CREATE TABLE album_feature (
	id INT IDENTITY,
	album_id INT,
	feature_id INT,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE feature_type (
	id INT IDENTITY,
	name VARCHAR(255),
	description TEXT,
	PRIMARY KEY(id)
);


CREATE TABLE binary_data (
	id INT IDENTITY,
	data VARBINARY,
	PRIMARY KEY(id)
);


