CREATE DATABASE smdp;
USE smdp;

CREATE TABLE album (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	audio_class_id INT(11) UNSIGNED,
	artist_id INT(11) UNSIGNED,
	album_name VARCHAR(255),
	track_list TEXT,
	PRIMARY KEY(id)
);


CREATE TABLE lyrics (
	song_id BIGINT(20) UNSIGNED,
	lyrics TEXT
);


CREATE TABLE musicbrainz (
	song_id BIGINT(20) UNSIGNED,
	TRM_id VARCHAR(255),
	artist VARCHAR(255),
	album VARCHAR(255),
	title VARCHAR(255),
	genre VARCHAR(255),
	year INT(11) UNSIGNED
);


CREATE TABLE freedb (
	album_id BIGINT(20) UNSIGNED,
	genre INT(11),
	discid VARCHAR(10),
	dtitle VARCHAR(255),
	dartist VARCHAR(255),
	extd TEXT
);


CREATE TABLE correlations (
	object_1 BIGINT(20) UNSIGNED,
	object_2 BIGINT(20) UNSIGNED,
	relation SMALLINT(6) UNSIGNED,
	type INT(11) UNSIGNED
);


CREATE TABLE song (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	genre_id INT(11) UNSIGNED,
	album_id BIGINT(20) UNSIGNED,
	artist_id BIGINT(20) UNSIGNED,
	file_id BIGINT(20) UNSIGNED,
	PRIMARY KEY(id)
);


CREATE TABLE media (
	id INT(11) UNSIGNED AUTO_INCREMENT NOT NULL,
	name VARCHAR(20),
	PRIMARY KEY(id)
);


CREATE TABLE media_file (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	media_id INT(11) UNSIGNED,
	filename VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE file_feature (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	file_id BIGINT(20) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE media_feature (
	id INT(11) UNSIGNED AUTO_INCREMENT NOT NULL,
	media_id INT(11) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE song_feature (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	song_id BIGINT(20) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE artist (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	artist_name VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE artist_feature (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	artist_id BIGINT(20) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE audio_class (
	id INT(11) UNSIGNED  AUTO_INCREMENT NOT NULL,
	audio_class_type_id INT(11) UNSIGNED,
	descr VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE audio_class_type (
	id INT(11) UNSIGNED  AUTO_INCREMENT NOT NULL,
	descr VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE collection (
	id BIGINT(20) UNSIGNED,
	name VARCHAR(255)
);


CREATE TABLE collection_feature (
	id BIGINT(20) UNSIGNED,
	collection_id BIGINT(20) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	type VARCHAR(255)
);


CREATE TABLE tag_feature (
	id INT(11) UNSIGNED AUTO_INCREMENT NOT NULL,
	tag_id INT(11) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE tag (
	id INT(11) UNSIGNED AUTO_INCREMENT NOT NULL,
	file_id BIGINT(20) UNSIGNED,
	name VARCHAR(20),
	PRIMARY KEY(id)
);


CREATE TABLE album_feature (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	album_id BIGINT(20) UNSIGNED,
	feature_id BIGINT(20) UNSIGNED,
	value VARCHAR(255),
	PRIMARY KEY(id)
);


CREATE TABLE feature_type (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	name VARCHAR(255),
	description TEXT,
	PRIMARY KEY(id)
);


CREATE TABLE binary_data (
	id BIGINT(20) UNSIGNED AUTO_INCREMENT NOT NULL,
	data BLOB,
	PRIMARY KEY(id)
);


