CREATE DATABASE smdp;
\c smdp

CREATE TABLE album (
	id SERIAL,
	audio_class_id INT,
	artist_id INT,
	album_name VARCHAR(255),
	track_list TEXT
);


CREATE TABLE lyrics (
	song_id BIGINT,
	lyrics TEXT
);


CREATE TABLE musicbrainz (
	song_id BIGINT,
	TRM_id VARCHAR(255),
	artist VARCHAR(255),
	album VARCHAR(255),
	title VARCHAR(255),
	genre VARCHAR(255),
	year INT
);


CREATE TABLE freedb (
	album_id BIGINT,
	genre INT,
	discid VARCHAR(10),
	dtitle VARCHAR(255),
	dartist VARCHAR(255),
	extd TEXT
);


CREATE TABLE correlations (
	object_1 BIGINT,
	object_2 BIGINT,
	relation SMALLINT,
	type INT
);


CREATE TABLE song (
	id SERIAL,
	genre_id INT,
	album_id BIGINT,
	artist_id BIGINT,
	file_id BIGINT
);


CREATE TABLE media (
	id SERIAL,
	name VARCHAR(20)
);


CREATE TABLE media_file (
	id SERIAL,
	media_id INT,
	filename VARCHAR(255)
);


CREATE TABLE file_feature (
	id SERIAL,
	file_id BIGINT,
	feature_id BIGINT,
	value VARCHAR(255)
);


CREATE TABLE media_feature (
	id SERIAL,
	media_id INT,
	feature_id BIGINT,
	value VARCHAR(255)
);


CREATE TABLE song_feature (
	id SERIAL,
	song_id BIGINT,
	feature_id BIGINT,
	value VARCHAR(255)
);


CREATE TABLE artist (
	id SERIAL,
	artist_name VARCHAR(255)
);


CREATE TABLE artist_feature (
	id SERIAL,
	artist_id BIGINT,
	feature_id BIGINT,
	value VARCHAR(255)
);


CREATE TABLE audio_class (
	id SERIAL,
	audio_class_type_id INT,
	descr VARCHAR(255)
);


CREATE TABLE audio_class_type (
	id SERIAL,
	descr VARCHAR(255)
);


CREATE TABLE collection (
	id BIGINT,
	name VARCHAR(255)
);


CREATE TABLE collection_feature (
	id BIGINT,
	collection_id BIGINT,
	feature_id BIGINT,
	type VARCHAR(255)
);


CREATE TABLE tag_feature (
	id SERIAL,
	tag_id INT,
	feature_id BIGINT,
	value VARCHAR(255)
);


CREATE TABLE tag (
	id SERIAL,
	file_id BIGINT,
	name VARCHAR(20)
);


CREATE TABLE album_feature (
	id SERIAL,
	album_id BIGINT,
	feature_id BIGINT,
	value VARCHAR(255)
);


CREATE TABLE feature_type (
	id SERIAL,
	name VARCHAR(255),
	description TEXT
);


CREATE TABLE binary_data (
	id SERIAL,
	data BYTEA
);


