#!/usr/bin/perl
# $Id: sql-generator.pl,v 1.4 2001/08/15 22:39:52 fkr Exp $

use Getopt::Long;

$VERSION = "sql-generator: 0.01";

$results = &GetOptions( "task=s" => \$task,     # what do we generate?
					    "h", \$usage);          # I need help! 

if(!($results)) {
	&usage();
}

if(@ARGV < 1) {
    &usage();
	} else {
	$infile = shift;                # input file, Dia XML formatted
    $outfile = shift;               # output file, filled with SQL statements
		        
    if($outfile) {
		open(STDOUT, ">$outfile") or die "$outfile: $!n";
	}
}


open(CSV_FILE,"<$infile") or die "failed to open $infile in read-mode: $!\n";

while(<CSV_FILE>) {
	# jump comments
	if($_ =~ /^#.*/) {
            next;
    }

	if($task eq "id3") {
		@fields = split /,/, $_;
    	chomp($fields[0]);
	    chomp($fields[1]);
		
		# sanity-check	
		if(($fields[0] ne "") && ($fields[1] ne "")) {
			print STDOUT "INSERT INTO feature_type (name, description) ".
			             "VALUES ('$fields[0]','$fields[1]');\n";
		}
	}
	
}

close(CSV_FILE);
close(STDOUT);

sub usage() {
    print STDOUT <<E_O_USAGE;

	$VERSION

	Usage:  sql-generator.pl --task=[task] infile.csv [outfile.sql]

	If no outfile is given, output is send to console. (stdout)
	Following task's available:		id3 [ convert id3.csv ]

E_O_USAGE
exit;
}
